//                        attiny85
//             reset -+---+- power
//      (output) pb3 -+*  +- pb2 (output)
// (touch input) pb4 -+   +- pb1 (output)
//            ground -+---+- pb0 (output)


int calibration = 0;
int previous;

void setup()
{
  for (int i = 0; i < 4; i++)
    pinMode(i, OUTPUT);
  
  delay(100);
  for (int i = 0; i < 8; i++) {
    calibration += chargeTime(PB4);
    delay(20);
  }
  calibration = (calibration + 4) / 8;
}

void loop()
{
  int n = chargeTime(PB4);
  
  if (n > calibration && previous <= calibration) {
    for (int j = 0; j < 3; j++) {
      for (int i = 0; i < 4; i++) 
        digitalWrite(i, HIGH);
      delay(30);
      for (int i = 0; i < 4; i++) 
        digitalWrite(i, LOW);
      delay(50);
    }
    delay(600);
  }
  
  previous = n;
  
  delayMicroseconds(500);
}

byte chargeTime(byte pin)
{
  byte mask = (1 << pin);
  byte i;

  DDRB &= ~mask; // input
  PORTB |= mask; // pull-up on

  for (i = 0; i < 16; i++) {
    if (PINB & mask) break;
  }

  PORTB &= ~mask; // pull-up off
  DDRB |= mask; // discharge

  return i;
}

